/*
** cmdproc.h --- subroutines respect to each command.
**
** Copyright (C) 2000, 2001 Bilingual Emacspeak Project <inoue@argv.org>
**
** Last modified: $Date: 2001/01/14 08:42:08 $ by $Author: inoue $
** Keywords: Emacs, Emacspeak, speech, Linux
**
** This file is part of BEP (Bilingual Emacspeak Project) 
** <http://www.argv.org/bep/>
** This file is originally written by Gary Bishop, and modified by BEP
** to make a bilingual, Japanese and English, DECTalk-like speech server 
** running under Windows.
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef CMDPROC_H
#define CMDPROC_H

int cmd_q(ss_queue *q, char *pcCmd, char **pcEndCmd);
int cmd_d (ss_queue *q, dTalkParam *dt,
	   ssSharedInfo *info, char *pcCmd, char **pcEndCmd);
void cmd_s (ss_queue *q, ssSharedInfo *info, char *pcCmd, char **pcEndCmd);
int cmd_unknown(char *pcCmd, char **pcEndCmd);
void cmd_tts_set_speech_rate(VoiceSet *, char *, char **);
void cmd_tts_set_punctuations(VoiceSet *, char *, char **);
int cmd_tts_say(ss_queue *q, dTalkParam *dt,
		ssSharedInfo *info, char *pcCmd, char **pcEndCmd);
void cmd_l(ss_queue *q, dTalkParam *dt,
	   ssSharedInfo *info, char *pcCmd, char **pcEndCmd);

#endif
