/*
** dic.cpp --- Hash dictionary
**
** Copyright (C) 2000, 2001 Bilingual Emacspeak Project <inoue@argv.org>
**
** Last modified: $Date: 2001/01/14 08:42:08 $ by $Author: inoue $
** Keywords: Emacs, Emacspeak, speech, Linux
**
** This file is part of BEP (Bilingual Emacspeak Project) 
** <http://www.argv.org/bep/>
** This file is originally written by Gary Bishop, and modified by BEP
** to make a bilingual, Japanese and English, DECTalk-like speech server 
** running under Windows.
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
/* ǥХå/顼åνϤˤϡιԤ򥳥Ȥˤޤ */
/* #define DEBUG_DIC*/

#include "dic.h"

/* Хѿ */
/* for dic(N)ChangeWordX() */
static char DicDummyCont='\0';

/* ؿdicGetKey
	bufɤߡkey_contSepcommentSep
	ФƤ'\0'졢ֹ֤*/

int dicGetKey(Dictionary *dicp,char buf[])
{
  int i;
  for(i=0;;i++)
    {
      if((buf[i]==dicp->commentSep)||(buf[i]=='\0'))  /*contʤ*/
	{
	  buf[i]='\0';
	  dicp->eor_flg=1;
	  break;
	}
      else if(buf[i]==dicp->key_contSep)              /*cont*/
	{
	  buf[i]='\0';
	  break;
	}
    }
  return(i+1);
}


/*ؿdicGetCont
	bufɤߡcommentSep'\0'ФƤ
   '0'졢ֹ֤*/

int dicGetCont(Dictionary *dicp,char buf[],int ofset)
{
  int i;
  for(i=ofset;;i++)
    {
      if((buf[i]==dicp->commentSep)||(buf[i]=='\0'))
	{
	  buf[i]='\0';
	  dicp->eor_flg=1;
	  break;
	}
    }
  return(i+1);
}


/* ؿdicProcessHeader
	  إåμ갷
	  إåȳϵ(comment)
	  ڤ국(separator)ѿcommentSepkey_contSep
	  إåιԿ֤إåϾάǽ
	  إåʤȤ0إå۾ΤȤ-1֤
	  إåȤϡȤ
		%{
		comment #      ʥǥեȤϥ֡
		separator ,    ʥǥեȤϥڡ
		%}
	  Ȥȡ
		key,content#comment
	  Ȥˤʤ롣 */

int dicProcessHeader(Dictionary *dicp,FILE *pfp)
{
  int sep=0,lineCnt=0;
  char buf[MaxLineLength];

  buf[0]='\0';
  while(buf[0]=='\0')
    {
      fgets(buf,MaxLineLength,pfp);
      dicGetKey(dicp, buf);
    }
  if(!str_eq(buf,HeaderBeg))
    {
      fseek(pfp, 0, SEEK_SET);
#ifdef DEBUG_DIC
      fprintf(stderr, "dictionary %s header processing is not required\n", dicp->dicFileName);
#endif
      return(0);
    }
  if(!str_eq(buf,HeaderEnd))
    while(1)
      {
	fgets(buf,MaxLineLength,pfp);
	lineCnt++;
	sep=dicGetKey(dicp, buf);
	if(str_eq(buf,"comment"))
	  dicp->commentSep=buf[sep];
	else if(str_eq(buf,"separator"))
	  dicp->key_contSep=buf[sep];
	else if(str_eq(buf,HeaderEnd))
	  {
	    lineCnt--;
	    break;
	  }
	else
	  {
#ifdef DEBUG_DIC
	    fprintf(stderr, "%s: invalid header\n", dicp->dicFileName);
#endif
	    return -1;
	  }
      }
  return(lineCnt);
}


/*ؿdicKeyHash
	ơϥå֤ͤ*/

unsigned int dicKeyHash(char *name)
{
  unsigned int hashVal;

  for(hashVal=0;*name;name++)   /*ϥåͤη׻*/
    hashVal=(*name+31*hashVal)%HashPrime;
  return(hashVal);
}

/*ؿdicNKeyHash
	ơϥå֤ͤĹС*/

unsigned int dicNKeyHash(char *name, int length)
{
  unsigned int hashVal=0;
char *endp;

  for(endp=name+length;name<endp;name++)   /*ϥåͤη׻*/
    hashVal=(*name+31*hashVal)%HashPrime;
  return(hashVal);
}

/*ؿdicLoadDictionary
	keycontϥå幽¤֤
	ȥե̾Ȥ롣*/
/* : 0=ｪλ 1=ط顼 2=ե륪ץ󥨥顼 
   3=إåΰ۾ */

int dicLoadDictionary(Dictionary *dicp,char *fileName)
{
  int sep, sep2, i,hashNum, llen;
  char buf[MaxLineLength];
  dicRecord *tmp;
  FILE *fp;

  for(i=0;i<HashPrime;i++) /*ϥåơ֥ν*/
    dicp->dicBase[i]=NULL;
  dicp->commentSep=TAB;
  dicp->key_contSep=SPACE;
  dicp->eor_flg=0;
  dicp->entryNum=0;
  dicp->dicFileName=NULL;
  if((dicp->dicFileName=(char *)malloc(sizeof(char)*strlen(fileName)+1))
     ==NULL)
    {
#ifdef DEBUG_DIC
      fprintf(stderr, "memory allocation error\n");
#endif
      return 1;
    }
  strcpy(dicp->dicFileName,fileName);
#ifdef MSDOS
  if((fp=fopen(dicp->dicFileName,"rt"))==NULL)
#else
  if((fp=fopen(dicp->dicFileName,"r"))==NULL)
#endif
    {
#ifdef DEBUG_DIC
      fprintf(stderr, "file %s can not be opend\n",dicp->dicFileName);
#endif
      return 2;
    }
  if(dicProcessHeader(dicp, fp)<0) return 3;
  while(fgets(buf,MaxLineLength,fp)!=NULL)
    {
llen=strlen(buf);
if(llen>0) buf[--llen]='\0'; /* Ǹפ'\n' */
if(llen==0 || buf[0]==dicp->commentSep || buf[0]==dicp->key_contSep)
  continue; /* ̣ΤʤԤʤ̵ */
      dicp->eor_flg=0;
      sep=dicGetKey(dicp, buf);
      hashNum=dicKeyHash(buf);
      if((tmp=(dicRecord *)malloc(sizeof(dicRecord)))==NULL)
	{
#ifdef DEBUG_DIC
	  fprintf(stderr, "%s: object generation error\n", dicp->dicFileName);
#endif
	  return 1;
	}
      tmp->key=NULL; /*  */
      tmp->cont=NULL;
      tmp->attr = 0;
      tmp->next=NULL;
      if((tmp->key=(char *)malloc(sizeof(char)*(strlen(buf)+1)))
	 ==NULL)
	{
#ifdef DEBUG_DIC
	  fprintf(stderr, "memory allocation error\n");
#endif
	  return 1;
	}
      strcpy(tmp->key,buf);
      if(!(dicp->eor_flg))
	{
	  sep2 = dicGetKey(dicp,&buf[sep]);
	  if((tmp->cont=(char *)malloc(sizeof(char)*(strlen
						     (&buf[sep])+1)))==NULL)
	    {
#ifdef DEBUG_DIC
	      fprintf(stderr, "memory allocation error\n");
#endif	      
return 1;
	    }
	  strcpy(tmp->cont,&buf[sep]);
	}
      /* read attribute */
      if (!(dicp->eor_flg)) {
	dicGetCont(dicp, buf, sep2);
	tmp->attr = atoi(&buf[sep2]);
      }
      tmp->next=dicp->dicBase[hashNum];
      dicp->dicBase[hashNum]=tmp;
      dicp->entryNum++;
    }
  fclose(fp);
return 0;
}


/*ؿdicHashSearch
	keyơ򸡺롣
	¸ߤ餽keyõݥ󥿤֤
	¸ߤʤäNULL֤*/

dicRecord *dicHashSearch(Dictionary *dicp,char *key)
{
  int hashNum;             /*ϥå*/
  dicRecord *tmp;

  hashNum=dicKeyHash(key);
  if(dicp->dicBase[hashNum]==NULL)
    return(NULL);
  else if(str_eq(dicp->dicBase[hashNum]->key,key))
    return(dicp->dicBase[hashNum]);
  else
    {
      tmp=dicp->dicBase[hashNum];
      while(tmp!=NULL)
	{
	  if(str_eq(tmp->key,key))
	    break;
	  tmp=tmp->next;
	}
      return(tmp);
    }
}

/* ؿdicNHashSearch: dicHashSearchĹС
   裳keyȹѤĹ */

dicRecord *dicNHashSearch(Dictionary *dicp,char *key, int length)
{
  int hashNum;             /*ϥå*/
  dicRecord *tmp;

  hashNum=dicNKeyHash(key, length);
  if(dicp->dicBase[hashNum]==NULL)
    return(NULL);
  else if(strn_eq(dicp->dicBase[hashNum]->key,key,length)
	  && (int)strlen(dicp->dicBase[hashNum]->key) == length)
    return(dicp->dicBase[hashNum]);
  else
    {
      tmp=dicp->dicBase[hashNum];
      while(tmp!=NULL)
	{
	  if(strn_eq(tmp->key,key,length)
	     && (int)strlen(tmp->key) == length)
	    break;
	  tmp=tmp->next;
	}
      return(tmp);
    }
}

/*ؿdicChangeWord
	keyơkeycont֤
	ҥåȤ쥳ɤcontʤNULL֤ */

char *dicChangeWord(Dictionary *dicp,char *key)
{
  dicRecord *tmp;

  tmp=dicHashSearch(dicp,key);
  if(tmp==NULL || tmp->cont==NULL)
    return(NULL);
  return(tmp->cont);
}

/* ؿdicNChangeWord: dicChangeWord ĹС */

char *dicNChangeWord(Dictionary *dicp,char *key,int length)
{
  dicRecord *tmp;

  tmp=dicNHashSearch(dicp,key,length);
  if(tmp==NULL || tmp->cont==NULL)
    return(NULL);
  return(tmp->cont);
}

/*ؿdicChangeWordX
	keyơkeycont֤NULL֤
	顼åФ""äؤΥݥ󥿤֤*/

char *dicChangeWordX(Dictionary *dicp,char *key)
{
  dicRecord *tmp;

  tmp=dicHashSearch(dicp,key);
  if(tmp==NULL || tmp->cont==NULL) {
#ifdef DEBUG_DIC
    fprintf(stderr, "\ndicChangeWordX: cont not found: %s\n", key);
#endif
    return (&DicDummyCont);
  }
  return(tmp->cont);
}

char *dicNChangeWordX(Dictionary *dicp,char *key,int length)
{
  dicRecord *tmp;

  tmp=dicNHashSearch(dicp,key,length);
  if(tmp==NULL || tmp->cont == NULL) {
#ifdef DEBUG_DIC
    int i;
    fprintf(stderr, "\ndicNChangeWordX: cont not found: ");
    for(i=0; i<length; i++)
      fputc(key[i], stderr);
    fputc('\n', stderr);
#endif
    return(&DicDummyCont);
  }
  return(tmp->cont);
}

/* ؿdicSearchNext dicHashSearchǸĤä쥳ɤΥݥ󥿤ȥ
   ꡢƱΥĥ쥳ɤꥹõ롣 */
dicRecord *dicSearchNext(dicRecord *recp, char *key)
{
  dicRecord *tmp;
  if(recp==NULL) return(NULL);
  tmp=recp->next;
  while(tmp!=NULL) {
    if(str_eq(tmp->key, key)) break;
    tmp=tmp->next;
  }
  return(tmp);
}

/* ؿdicNSearchNext: dicSearchNext ĹС */

dicRecord *dicNSearchNext(dicRecord *recp, char *key, int length)
{
  dicRecord *tmp;
  if(recp==NULL) return(NULL);
  tmp=recp->next;
  while(tmp!=NULL) {
    if(strn_eq(tmp->key, key, length)) break;
    tmp=tmp->next;
  }
  return(tmp);
}

/* ؿdicSearchPair
   ƤΥڥꡢõƱڥФ
   dicRecordΥݥ󥿤򡢤ʤNULL֤ */
dicRecord *dicSearchPair(Dictionary *dicp, char *key, char *cont)
{
  dicRecord *tmp;
  tmp=dicHashSearch(dicp, key);
  while(tmp!=NULL)
    {
      if((tmp->cont!=NULL) && str_eq(cont, tmp->cont)) break;
      else tmp=dicSearchNext(tmp, key);
    }
  return(tmp);
}

/* ؿdicNSearchPair
   ƤΥڥꡢõƱڥФ
   dicRecordΥݥ󥿤򡢤ʤNULL֤
 ƤΤ줾ĹꤹС */
dicRecord *dicNSearchPair(Dictionary *dicp, char *key, char *cont,
			  int length1, int length2)
{
  dicRecord *tmp;
  tmp=dicNHashSearch(dicp, key, length1);
  while(tmp!=NULL)
    {
      if((tmp->cont!=NULL) && strn_eq(cont, tmp->cont, length2)) break;
      else tmp=dicNSearchNext(tmp, key, length1);
    }
  return(tmp);
}

