/*
** kanjifn.h --- Kanji-related functions(header).
**
** Copyright (C) 2000, 2001 Bilingual Emacspeak Project <inoue@argv.org>
**
** Last modified: $Date: 2001/01/14 08:42:09 $ by $Author: inoue $
** Keywords: Emacs, Emacspeak, speech, Linux
**
** This file is part of BEP (Bilingual Emacspeak Project) 
** <http://www.argv.org/bep/>
** This file is originally written by Gary Bishop, and modified by BEP
** to make a bilingual, Japanese and English, DECTalk-like speech server 
** running under Windows.
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef __KANJIFN_H
#define __KANJIFN_H
#include <stdio.h>
#define iskanji(c) \
((((c) & 0xff)>=0x81 && ((c) & 0xff ) <= 0x9f || ((c) & 0xff)>= 0xe0 && ((c) & 0xff)<=0xfc) ? 1 : 0)
#define iskanji2(c) \
((((c) >= 0x40 && (c) <= 0x7e ) || ((c) >=0x80 && (c)<= 0xfc )) ? 1 : 0)
#define iszenalpha(c) \
(((*c) >= 0x81 && (*(c+1)) == 0x66) \
|| ((*c) == 0x82 && \
(((*(c+1)) >= 0x60 && (*(c+1)) <= 0x79)\
|| ((*(c+1)) >= 0x81 && (*(c+1)) <= 0x91))))

 /* constant */
#define ENG_KANA_MAX_FLAGMENT 10

/* prototypes */
char jpZenToHan(char *);

/* convert alphanumeric string to Katakana reading string */
int jpEngToKana(Dictionary *dicp, char *pszIn, int inLen, char **ppszOut);

#endif
