/*
** ssqueue.h --- implementation of speech queue(header).
**
** Copyright (C) 2000, 2001 Bilingual Emacspeak Project <inoue@argv.org>
**
** Last modified: $Date: 2001/01/14 08:42:09 $ by $Author: inoue $
** Keywords: Emacs, Emacspeak, speech, Linux
**
** This file is part of BEP (Bilingual Emacspeak Project) 
** <http://www.argv.org/bep/>
** This file is originally written by Gary Bishop, and modified by BEP
** to make a bilingual, Japanese and English, DECTalk-like speech server 
** running under Windows.
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
#ifndef SS_QUEUE_H
#define SS_QUEUE_H

#define SS_QUEUE_BLOCK_SIZE 1024

struct ss_queue_block {
  string text;
  ss_queue_block *prev, *next;
  ss_queue_block::ss_queue_block();
};

struct ss_queue {
  VoiceSet *vset;
  ss_queue_block *top;
  ss_queue_block *end;
  ss_queue();
  ~ss_queue();
  void initVoice();
  ss_queue_block *push_text(
				      const char *text,
				      int len
				      );
  ss_queue_block *push_text_add(
				      const char *text,
				      int len
				      );
  void pop(dTalkParam *dt, ssSharedInfo *info);
  int empty();
  void clear();
};

#endif /* SS_QUEUE_H */

